// Generated by CoffeeScript 1.7.0
var Exp, Token, Unit,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

Token = require('./token').Token;

Unit = require('./unit').Unit;

Exp = (function(_super) {
  __extends(Exp, _super);

  Exp.prototype.isExp = true;

  Exp.prototype.isToken = false;

  function Exp(opts) {
    this.parent = opts.parent;
    this.index = opts.index;
    this.caret = opts.caret;
    this.list = opts.item.map((function(_this) {
      return function(item, index) {
        return new (Array.isArray(item) ? Exp : Token)({
          parent: _this,
          index: index,
          item: item,
          caret: _this.caret
        });
      };
    })(this));
    this.indented = false;
  }

  Exp.prototype.len = function() {
    return this.list.length;
  };

  Exp.prototype.getFirst = function() {
    return this.list[0];
  };

  Exp.prototype.markIndented = function() {
    return this.indented = true;
  };

  Exp.prototype.makeInline = function() {
    var simpleJoin;
    simpleJoin = function(item) {
      return item.list.map(function(obj) {
        if (obj.isToken) {
          return obj.make();
        } else if (item.isExp) {
          return "(" + (simpleJoin(obj)) + ")";
        }
      }).join(' ');
    };
    return simpleJoin(this);
  };

  Exp.prototype.makeHead = function() {
    return "(" + (this.makeInline()) + ")";
  };

  Exp.prototype.column = function() {
    var str;
    str = this.makeInline();
    while (str.length < 20) {
      str += ' ';
    }
    return str;
  };

  Exp.prototype.format = function() {
    var item, _i, _len, _ref;
    if (this.len() === 0) {
      return;
    }
    _ref = this.list;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      item = _ref[_i];
      if (item.is('token first')) {
        console.log(item.column(), 'token first');
        item.format();
        this.caret.setState('word');
      } else if (item.is('exp last empty word')) {
        console.log(item.column(), 'exp last empty word');
        this.caret.token('$').setState('word');
      } else if (item.is('exp first')) {
        console.log(item.column(), 'exp first');
        this.caret.token(item.makeHead()).setState('word');
      } else if (item.is('exp empty word last')) {
        console.log(item.column(), 'exp empty word last');
        this.caret.token('$').setState('word');
      } else if (item.is('token word')) {
        console.log(item.column(), 'token word');
        this.caret.token(item.text).setState('word');
      } else if (item.is('token block')) {
        console.log(item.column(), 'token block');
        this.caret.newline().token(',').token(item.text).setState('word');
      } else if (item.is('exp short last word')) {
        console.log(item.column(), 'exp short last word');
        this.caret.token('$');
        item.getFirst().format();
        this.caret.setState('word');
      } else if (item.is('exp short nested align')) {
        console.log(item.column(), 'exp short nested align');
        this.markIndented();
        this.caret.indent().newline().token('$');
        item.getFirst().format();
        this.caret.setState('block');
      } else if (item.is('exp short nested indented')) {
        console.log(item.column(), 'exp short nested indented');
        this.caret.newline().token('$');
        item.getFirst().format();
        this.caret.setState('block');
      } else if (item.is('exp long nested align last word')) {
        console.log(item.column(), 'exp long nested align last word');
        this.caret.token('$');
        item.format();
        this.caret.setState('block');
      } else if (item.is('exp plain empty word')) {
        console.log(item.column(), 'exp plain empty word');
        this.caret.token('()').setState('word');
      } else if (item.is('exp plain empty block')) {
        console.log(item.column(), 'exp plain empty block');
        this.caret.newline().token(',').token('()').setState('word');
      } else if (item.is('exp plain last word')) {
        console.log(item.column(), 'exp plain last word');
        this.caret.token('$').token(item.makeInline()).setState('word');
      } else if (item.is('exp plain word')) {
        console.log(item.column(), 'exp plain word');
        this.caret.token(item.makeHead()).setState('word');
      } else if (item.is('exp plain block')) {
        console.log(item.column(), 'exp plain block');
        this.caret.newline().token(item.makeInline());
        this.caret.setState('block');
      } else if (item.is('exp nested align')) {
        console.log(item.column(), 'exp nested align');
        this.markIndented();
        this.caret.indent().newline();
        item.format();
        this.caret.setState('block');
      } else if (item.is('exp nested indented')) {
        console.log(item.column(), 'exp nested indented');
        this.caret.newline();
        item.format();
        this.caret.setState('block');
      } else {
        console.log(item.column(), '!!! is not recognized');
      }
    }
    if (this.indented) {
      return this.caret.unindent();
    }
  };

  return Exp;

})(Unit);

exports.Exp = Exp;

//# sourceMappingURL=exp.map
